%define	lib_major 1
%define	lib_name %{name}%{lib_major}

%define build_biarch 0
# Enable bi-arch build on ppc64, sparc64 and x86-64
%ifarch sparcv9 sparc64 x86_64 ppc64
%define build_biarch 1
%endif
%ifarch sparcv9
%define	_lib	lib64
%endif

%define build_diet 1

Summary:	The zlib compression and decompression library
Name:		zlib
Version:	1.2.3
Release:	%mkrel 12
Group:		System/Libraries
License:	BSD
URL:		http://www.gzip.org/zlib/
Source0:	http://prdownloads.sourceforge.net/libpng/%{name}-%{version}.tar.bz2
Patch0:		zlib-1.2.1-glibc.patch
Patch1:		zlib-1.2.1-multibuild.patch
Patch2:		zlib-1.2.2.2-build-fPIC.patch
Patch4:		zlib-1.2.1.1-deb-alt-inflate.patch
BuildRequires:	setarch
%if %{build_diet}
BuildRequires:	dietlibc-devel
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%package -n	%{lib_name}
Summary:	The zlib compression and decompression library
Group:		System/Libraries
Obsoletes:	libz, libz1, %{name}
Provides:	libz = %{version}-%{release} libz1 = %{version}-%{release} %{name} = %{version}-%{release}

%description -n	%{lib_name}
The zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%package -n	%{lib_name}-devel
Summary:	Header files and libraries for developing apps which will use zlib
Group:		Development/C
Requires:	%{lib_name} = %{version}-%{release}
Obsoletes:	libz1-devel libz-devel zlib-devel
Provides:	libz-devel = %{version}-%{release} libz1-devel = %{version}-%{release} %{name}-devel = %{version}-%{release}

%description -n	%{lib_name}-devel
The zlib-devel package contains the header files and libraries needed
to develop programs that use the zlib compression and decompression
library.

Install the zlib-devel package if you want to develop applications that
will use the zlib library.

%prep

%setup -q
%patch0 -p1
%patch1 -p1 -b .multibuild
%patch2 -p1 -b .build-fPIC
%patch4 -p1 -b .deb-alt-inflate

%build
#(peroyvind): be sure to remove -m64/-m32 flags as they're not overridable
RPM_OPT_FLAGS="`echo $RPM_OPT_FLAGS| sed -e 's/-m.. //g'`"
mkdir objs
pushd objs
  CFLAGS="$RPM_OPT_FLAGS" \
%if %{build_biarch}
  CC="%{__cc} -m64" \
%endif
  ../configure --shared --prefix=%{_prefix} --libdir=%{_libdir}
  %make
  make test
  ln -s ../zlib.3 .
popd

%if %{build_biarch}
%ifarch %{sunsparc}
RPM_OPT_FLAGS_32="$RPM_OPT_FLAGS"
%else
RPM_OPT_FLAGS_32=`linux32 rpm --eval %%optflags`
%endif
mkdir objs32
pushd objs32
  CFLAGS="$RPM_OPT_FLAGS_32" CC="%{__cc} -m32" \
  ../configure --shared --prefix=%{_prefix}
  %make
  make test
  ln -s ../zlib.3 .
popd
%endif

%if %{build_diet}
mkdir objsdiet
pushd objsdiet
  CFLAGS="-Os" CC="diet gcc" \
  ../configure --prefix=%{_prefix}
  %make libz.a
popd
%endif

%install
rm -rf %{buildroot}

install -d %{buildroot}/%{_prefix}
install -d %{buildroot}/%{_libdir}

make install -C objs prefix=%{buildroot}%{_prefix} libdir=%{buildroot}%{_libdir}
%if %{build_biarch}
make install-libs -C objs32 prefix=%{buildroot}%{_prefix}
%endif

install -d %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/*.so.* %{buildroot}/%{_lib}/
ln -s ../../%{_lib}/libz.so.%{version} %{buildroot}%{_libdir}/

%if %{build_biarch}
install -d %{buildroot}/lib
mv %{buildroot}%{_prefix}/lib/*.so.* %{buildroot}/lib/
ln -s ../../lib/libz.so.%{version} %{buildroot}%{_prefix}/lib/
%endif

%if %{build_diet}
install -d %{buildroot}%{_prefix}/lib/dietlibc/lib-%{_arch}
install objsdiet/libz.a %{buildroot}%{_prefix}/lib/dietlibc/lib-%{_arch}/libz.a
%endif

%if %mdkversion < 200900
%post -n %{lib_name} -p /sbin/ldconfig
%endif

%if %mdkversion < 200900
%postun -n %{lib_name} -p /sbin/ldconfig
%endif

%clean
rm -fr %{buildroot}

%files -n %{lib_name}
%defattr(-, root, root)
%doc README
/%{_lib}/libz.so.*
%{_libdir}/libz.so.*
%if %{build_biarch}
/lib/libz.so.*
%{_prefix}/lib/libz.so.*
%endif

%files -n %{lib_name}-devel
%defattr(-, root, root)
%doc README ChangeLog algorithm.txt
%{_libdir}/*.a
%{_libdir}/*.so
%if %{build_biarch}
%{_prefix}/lib/*.a
%{_prefix}/lib/*.so
%endif
%if %{build_diet}
%{_prefix}/lib/dietlibc/lib-%{_arch}/libz.a
%endif
%{_includedir}/*
%{_mandir}/*/*


%changelog
* Thu Aug 07 2008 Thierry Vignaud <tvignaud@mandriva.com> 1.2.3-12mdv2009.0
+ Revision: 266170
- rebuild early 2009.0 package (before pixel changes)

* Tue Jun 10 2008 Oden Eriksson <oeriksson@mandriva.com> 1.2.3-11mdv2009.0
+ Revision: 217581
- rebuilt against dietlibc-devel-0.32

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Tue May 20 2008 Oden Eriksson <oeriksson@mandriva.com> 1.2.3-10mdv2009.0
+ Revision: 209452
- rebuilt with gcc43

* Tue Mar 04 2008 Oden Eriksson <oeriksson@mandriva.com> 1.2.3-9mdv2008.1
+ Revision: 178766
- rebuild

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Aug 15 2007 Olivier Blin <oblin@mandriva.com> 1.2.3-8mdv2008.0
+ Revision: 63510
- build dietlibc library with -Os (better, and fix weird segfault)

* Mon Aug 13 2007 Olivier Blin <oblin@mandriva.com> 1.2.3-7mdv2008.0
+ Revision: 62821
- move diet libz in _prefix/lib/dietlibc/lib-_arch (to follow gb's convention)

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - install static dietlibc library in correct place on sparc
    - package is now sparcv9 in stead of sparc64 on on sparc
    - be sure to set 64 bit environment also at link time as compiler on sparc
      defaults to 32 bit


* Thu Jan 25 2007 Olivier Blin <oblin@mandriva.com> 1.2.3-5mdv2007.0
+ Revision: 113526
- build a diet libz-diet.a archive

* Mon Dec 04 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.2.3-4mdv2007.1
+ Revision: 90324
- fix bi-arch builds with different -m32/-m64 optflags

  + Oden Eriksson <oeriksson@mandriva.com>
    - bzip2 cleanup

* Thu Oct 12 2006 Oden Eriksson <oeriksson@mandriva.com> 1.2.3-3mdv2007.1
+ Revision: 63458
- bunzip patches
- Import zlib

* Wed Oct 05 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.2.3-2mdk
- make it a biarch package on ppc64

* Fri Jul 22 2005 Nicolas Lcureuil <neoclust@mandriva.org> 1.2.3-1mdk
- New release 1.2.3
- Drop patch 5 ( Merged Upstream )

* Thu Jul 21 2005 Olivier Blin <oblin@mandriva.com> 1.2.2.2-3mdk
- from Vincent Danen: security fix for CAN-2005-2096

* Thu Jan 20 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.2.2.2-2mdk
- make sure we are compiling DSO with -fPIC in configure tests

* Thu Jan 13 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.2.2-1mdk
- 1.2.2.2
- drop packager tag

* Thu Dec 02 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.2.1-1mdk
- 1.2.2.1

* Sat Aug 28 2004 Frederic Lepied <flepied@mandrakesoft.com> 1.2.1.1-3mdk
- fix from Debian

* Tue Jul 13 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.1.1-2mdk
- change default compile flags only for 32 bits build when building on sparc64

* Sun May 30 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 1.2.1.1-1mdk
- 1.2.1.1
- spec cosmetics

